zenilib: zenilib/jni/external/sdl/SDL/SDL_audio.h File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Classes | Macros | Typedefs | Functions
SDL_audio.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_endian.h"`
`#include "SDL_mutex.h"`
`#include "SDL_thread.h"`
`#include "SDL_rwops.h"`
`#include "begin_code.h"`
`#include "close_code.h"`

Go to the source code of this file.

## Classes

struct | SDL_AudioCVT
struct | SDL_AudioSpec

## Macros

#define | SDL_AUDIOCVT_PACKED
#define | SDL_LoadWAV(file, spec, audio_buf, audio_len) SDL_LoadWAV_RW(SDL_RWFromFile(file, "rb"),1, spec,audio_buf,audio_len)
#define | SDL_MIX_MAXVOLUME 128
Audio flags
#define | SDL_AUDIO_MASK_BITSIZE (0xFF)
#define | SDL_AUDIO_MASK_DATATYPE (1<<8)
#define | SDL_AUDIO_MASK_ENDIAN (1<<12)
#define | SDL_AUDIO_MASK_SIGNED (1<<15)
#define | SDL_AUDIO_BITSIZE(x) (x & SDL_AUDIO_MASK_BITSIZE)
#define | SDL_AUDIO_ISFLOAT(x) (x & SDL_AUDIO_MASK_DATATYPE)
#define | SDL_AUDIO_ISBIGENDIAN(x) (x & SDL_AUDIO_MASK_ENDIAN)
#define | SDL_AUDIO_ISSIGNED(x) (x & SDL_AUDIO_MASK_SIGNED)
#define | SDL_AUDIO_ISINT(x) (!SDL_AUDIO_ISFLOAT(x))
#define | SDL_AUDIO_ISLITTLEENDIAN(x) (!SDL_AUDIO_ISBIGENDIAN(x))
#define | SDL_AUDIO_ISUNSIGNED(x) (!SDL_AUDIO_ISSIGNED(x))
Audio format flags
Defaults to LSB byte order.
#define | AUDIO_U8 0x0008
#define | AUDIO_S8 0x8008
#define | AUDIO_U16LSB 0x0010
#define | AUDIO_S16LSB 0x8010
#define | AUDIO_U16MSB 0x1010
#define | AUDIO_S16MSB 0x9010
#define | AUDIO_U16 AUDIO_U16LSB
#define | AUDIO_S16 AUDIO_S16LSB
int32 support
#define | AUDIO_S32LSB 0x8020
#define | AUDIO_S32MSB 0x9020
#define | AUDIO_S32 AUDIO_S32LSB
float32 support
#define | AUDIO_F32LSB 0x8120
#define | AUDIO_F32MSB 0x9120
#define | AUDIO_F32 AUDIO_F32LSB
Native audio byte ordering
#define | AUDIO_U16SYS AUDIO_U16LSB
#define | AUDIO_S16SYS AUDIO_S16LSB
#define | AUDIO_S32SYS AUDIO_S32LSB
#define | AUDIO_F32SYS AUDIO_F32LSB
Allow change flags
Which audio format changes are allowed when opening a device.
#define | SDL_AUDIO_ALLOW_FREQUENCY_CHANGE 0x00000001
#define | SDL_AUDIO_ALLOW_FORMAT_CHANGE 0x00000002
#define | SDL_AUDIO_ALLOW_CHANNELS_CHANGE 0x00000004
#define | SDL_AUDIO_ALLOW_ANY_CHANGE (SDL_AUDIO_ALLOW_FREQUENCY_CHANGE|SDL_AUDIO_ALLOW_FORMAT_CHANGE|SDL_AUDIO_ALLOW_CHANNELS_CHANGE)

## Typedefs

typedef SDL_AudioFormat | format
typedef Uint8 int | len
typedef struct SDL_AudioCVT | SDL_AudioCVT
typedef Uint32 | SDL_AudioDeviceID
typedef Uint16 | SDL_AudioFormat
| Audio format flags. More...
typedef struct SDL_AudioSpec | SDL_AudioSpec
typedef Uint8 * | stream

## Functions

DECLSPEC int SDLCALL | SDL_BuildAudioCVT (SDL_AudioCVT *cvt, SDL_AudioFormat src_format, Uint8 src_channels, int src_rate, SDL_AudioFormat dst_format, Uint8 dst_channels, int dst_rate)
DECLSPEC void SDLCALL | SDL_CloseAudio (void)
DECLSPEC void SDLCALL | SDL_CloseAudioDevice (SDL_AudioDeviceID dev)
DECLSPEC int SDLCALL | SDL_ConvertAudio (SDL_AudioCVT *cvt)
DECLSPEC void SDLCALL | SDL_FreeWAV (Uint8 *audio_buf)
DECLSPEC const char *SDLCALL | SDL_GetAudioDeviceName (int index, int iscapture)
DECLSPEC const char *SDLCALL | SDL_GetCurrentAudioDriver (void)
DECLSPEC int SDLCALL | SDL_GetNumAudioDevices (int iscapture)
DECLSPEC SDL_AudioSpec *SDLCALL | SDL_LoadWAV_RW (SDL_RWops *src, int freesrc, SDL_AudioSpec *spec, Uint8 **audio_buf, Uint32 *audio_len)
DECLSPEC void SDLCALL | SDL_MixAudio (Uint8 *dst, const Uint8 *src, Uint32 len, int volume)
DECLSPEC void SDLCALL | SDL_MixAudioFormat (Uint8 *dst, const Uint8 *src, SDL_AudioFormat format, Uint32 len, int volume)
DECLSPEC int SDLCALL | SDL_OpenAudio (SDL_AudioSpec *desired, SDL_AudioSpec *obtained)
DECLSPEC SDL_AudioDeviceID SDLCALL | SDL_OpenAudioDevice (const char *device, int iscapture, const SDL_AudioSpec *desired, SDL_AudioSpec *obtained, int allowed_changes)
typedef | void (SDLCALL *SDL_AudioCallback)(void *userdata
Driver discovery functions
These functions return the list of built in audio drivers, in the order that they are normally initialized by default.
DECLSPEC int SDLCALL | SDL_GetNumAudioDrivers (void)
DECLSPEC const char *SDLCALL | SDL_GetAudioDriver (int index)
Initialization and cleanup
DECLSPEC int SDLCALL | SDL_AudioInit (const char *driver_name)
DECLSPEC void SDLCALL | SDL_AudioQuit (void)
Pause audio functions
These functions pause and unpause the audio callback processing. They should be called with a parameter of 0 after opening the audio device to start playing sound. This is so you can safely initialize data for your callback function after opening the audio device. Silence will be written to the audio device during the pause.
DECLSPEC void SDLCALL | SDL_PauseAudio (int pause_on)
DECLSPEC void SDLCALL | SDL_PauseAudioDevice (SDL_AudioDeviceID dev, int pause_on)
Audio lock functions
The lock manipulated by these functions protects the callback function. During a SDL_LockAudio()/SDL_UnlockAudio() pair, you can be guaranteed that the callback function is not running. Do not call these from the callback function or you will cause deadlock.
DECLSPEC void SDLCALL | SDL_LockAudio (void)
DECLSPEC void SDLCALL | SDL_LockAudioDevice (SDL_AudioDeviceID dev)
DECLSPEC void SDLCALL | SDL_UnlockAudio (void)
DECLSPEC void SDLCALL | SDL_UnlockAudioDevice (SDL_AudioDeviceID dev)

## Audio state

Get the current audio state.
enum | SDL_AudioStatus { SDL_AUDIO_STOPPED = 0, SDL_AUDIO_PLAYING, SDL_AUDIO_PAUSED }
DECLSPEC SDL_AudioStatus SDLCALL | SDL_GetAudioStatus (void)
DECLSPEC SDL_AudioStatus SDLCALL | SDL_GetAudioDeviceStatus (SDL_AudioDeviceID dev)

## Detailed Description

Access to the raw audio mixing buffer for the SDL library.

Definition in file SDL_audio.h.

## Macro Definition Documentation

#define AUDIO_F32 AUDIO_F32LSB

Definition at line 114 of file SDL_audio.h.

Referenced by SDL_ConvertMono(), SDL_ConvertSurround(), and SDL_LoadWAV_RW().

#define AUDIO_F32LSB 0x8120

32-bit floating point samples

Definition at line 112 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32MSB_to_F32LSB(), SDL_Convert_S16LSB_to_F32LSB(), SDL_Convert_S16MSB_to_F32LSB(), SDL_Convert_S32LSB_to_F32LSB(), SDL_Convert_S32MSB_to_F32LSB(), SDL_Convert_S8_to_F32LSB(), SDL_Convert_U16LSB_to_F32LSB(), SDL_Convert_U16MSB_to_F32LSB(), SDL_Convert_U8_to_F32LSB(), and SDL_MixAudioFormat().

#define AUDIO_F32MSB 0x9120

As above, but big-endian byte order

Definition at line 113 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_F32MSB(), SDL_Convert_S16LSB_to_F32MSB(), SDL_Convert_S16MSB_to_F32MSB(), SDL_Convert_S32LSB_to_F32MSB(), SDL_Convert_S32MSB_to_F32MSB(), SDL_Convert_S8_to_F32MSB(), SDL_Convert_U16LSB_to_F32MSB(), SDL_Convert_U16MSB_to_F32MSB(), SDL_Convert_U8_to_F32MSB(), and SDL_MixAudioFormat().

#define AUDIO_F32SYS AUDIO_F32LSB

Definition at line 125 of file SDL_audio.h.

#define AUDIO_S16 AUDIO_S16LSB

Definition at line 96 of file SDL_audio.h.

Referenced by prepare_audiospec(), SDL_ConvertMono(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), SDL_LoadWAV_RW(), SDLTest_CommonArg(), and SDLTest_CommonCreateState().

#define AUDIO_S16LSB 0x8010

Signed 16-bit samples

Definition at line 92 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), PSPAUD_OpenDevice(), SDL_Convert_F32LSB_to_S16LSB(), SDL_Convert_F32MSB_to_S16LSB(), SDL_Convert_S16MSB_to_S16LSB(), SDL_Convert_S32LSB_to_S16LSB(), SDL_Convert_S32MSB_to_S16LSB(), SDL_Convert_S8_to_S16LSB(), SDL_Convert_U16LSB_to_S16LSB(), SDL_Convert_U16MSB_to_S16LSB(), SDL_Convert_U8_to_S16LSB(), SDL_MixAudioFormat(), and SDLTest_CommonArg().

#define AUDIO_S16MSB 0x9010

As above, but big-endian byte order

Definition at line 94 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_S16MSB(), SDL_Convert_F32MSB_to_S16MSB(), SDL_Convert_S16LSB_to_S16MSB(), SDL_Convert_S32LSB_to_S16MSB(), SDL_Convert_S32MSB_to_S16MSB(), SDL_Convert_S8_to_S16MSB(), SDL_Convert_U16LSB_to_S16MSB(), SDL_Convert_U16MSB_to_S16MSB(), SDL_Convert_U8_to_S16MSB(), SDL_MixAudioFormat(), and SDLTest_CommonArg().

#define AUDIO_S16SYS AUDIO_S16LSB

Definition at line 123 of file SDL_audio.h.

#define AUDIO_S32 AUDIO_S32LSB

Definition at line 105 of file SDL_audio.h.

Referenced by SDL_ConvertMono(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), and SDL_LoadWAV_RW().

#define AUDIO_S32LSB 0x8020

32-bit integer samples

Definition at line 103 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_S32LSB(), SDL_Convert_F32MSB_to_S32LSB(), SDL_Convert_S16LSB_to_S32LSB(), SDL_Convert_S16MSB_to_S32LSB(), SDL_Convert_S32MSB_to_S32LSB(), SDL_Convert_S8_to_S32LSB(), SDL_Convert_U16LSB_to_S32LSB(), SDL_Convert_U16MSB_to_S32LSB(), SDL_Convert_U8_to_S32LSB(), and SDL_MixAudioFormat().

#define AUDIO_S32MSB 0x9020

As above, but big-endian byte order

Definition at line 104 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_S32MSB(), SDL_Convert_F32MSB_to_S32MSB(), SDL_Convert_S16LSB_to_S32MSB(), SDL_Convert_S16MSB_to_S32MSB(), SDL_Convert_S32LSB_to_S32MSB(), SDL_Convert_S8_to_S32MSB(), SDL_Convert_U16LSB_to_S32MSB(), SDL_Convert_U16MSB_to_S32MSB(), SDL_Convert_U8_to_S32MSB(), and SDL_MixAudioFormat().

#define AUDIO_S32SYS AUDIO_S32LSB

Definition at line 124 of file SDL_audio.h.

#define AUDIO_S8 0x8008

Signed 8-bit samples

Definition at line 90 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_S8(), SDL_Convert_F32MSB_to_S8(), SDL_Convert_S16LSB_to_S8(), SDL_Convert_S16MSB_to_S8(), SDL_Convert_S32LSB_to_S8(), SDL_Convert_S32MSB_to_S8(), SDL_Convert_U16LSB_to_S8(), SDL_Convert_U16MSB_to_S8(), SDL_Convert_U8_to_S8(), SDL_ConvertMono(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), SDL_MixAudioFormat(), and SDLTest_CommonArg().

#define AUDIO_U16 AUDIO_U16LSB

Definition at line 95 of file SDL_audio.h.

Referenced by SDL_ConvertMono(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), and SDLTest_CommonArg().

#define AUDIO_U16LSB 0x0010

Unsigned 16-bit samples

Definition at line 91 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_U16LSB(), SDL_Convert_F32MSB_to_U16LSB(), SDL_Convert_S16LSB_to_U16LSB(), SDL_Convert_S16MSB_to_U16LSB(), SDL_Convert_S32LSB_to_U16LSB(), SDL_Convert_S32MSB_to_U16LSB(), SDL_Convert_S8_to_U16LSB(), SDL_Convert_U16MSB_to_U16LSB(), SDL_Convert_U8_to_U16LSB(), and SDLTest_CommonArg().

#define AUDIO_U16MSB 0x1010

As above, but big-endian byte order

Definition at line 93 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_Convert_F32LSB_to_U16MSB(), SDL_Convert_F32MSB_to_U16MSB(), SDL_Convert_S16LSB_to_U16MSB(), SDL_Convert_S16MSB_to_U16MSB(), SDL_Convert_S32LSB_to_U16MSB(), SDL_Convert_S32MSB_to_U16MSB(), SDL_Convert_S8_to_U16MSB(), SDL_Convert_U16LSB_to_U16MSB(), SDL_Convert_U8_to_U16MSB(), and SDLTest_CommonArg().

#define AUDIO_U16SYS AUDIO_U16LSB

Definition at line 122 of file SDL_audio.h.

#define AUDIO_U8 0x0008

Unsigned 8-bit samples

Definition at line 89 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), PSPAUD_OpenDevice(), SDL_CalculateAudioSpec(), SDL_Convert_F32LSB_to_U8(), SDL_Convert_F32MSB_to_U8(), SDL_Convert_S16LSB_to_U8(), SDL_Convert_S16MSB_to_U8(), SDL_Convert_S32LSB_to_U8(), SDL_Convert_S32MSB_to_U8(), SDL_Convert_S8_to_U8(), SDL_Convert_U16LSB_to_U8(), SDL_Convert_U16MSB_to_U8(), SDL_ConvertMono(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), SDL_LoadWAV_RW(), SDL_MixAudioFormat(), and SDLTest_CommonArg().

#define SDL_AUDIO_ALLOW_ANY_CHANGE (SDL_AUDIO_ALLOW_FREQUENCY_CHANGE|SDL_AUDIO_ALLOW_FORMAT_CHANGE|SDL_AUDIO_ALLOW_CHANNELS_CHANGE)

Definition at line 143 of file SDL_audio.h.

Referenced by SDL_OpenAudio().

#define SDL_AUDIO_ALLOW_CHANNELS_CHANGE 0x00000004

Definition at line 142 of file SDL_audio.h.

Referenced by open_audio_device().

#define SDL_AUDIO_ALLOW_FORMAT_CHANGE 0x00000002

Definition at line 141 of file SDL_audio.h.

Referenced by open_audio_device().

#define SDL_AUDIO_ALLOW_FREQUENCY_CHANGE 0x00000001

Definition at line 140 of file SDL_audio.h.

Referenced by open_audio_device().

#define SDL_AUDIO_BITSIZE | ( |  | x | ) | (x & SDL_AUDIO_MASK_BITSIZE)

Definition at line 75 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), PSPAUD_OpenDevice(), SDL_BuildAudioCVT(), SDL_BuildAudioTypeCVT(), SDL_CalculateAudioSpec(), SDL_ConvertStereo(), SDL_ConvertStrip(), SDL_ConvertStrip_2(), and SDL_LoadWAV_RW().

#define SDL_AUDIO_ISBIGENDIAN | ( |  | x | ) | (x & SDL_AUDIO_MASK_ENDIAN)

Definition at line 77 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), SDL_ConvertMono(), SDL_ConvertSurround(), and SDL_ConvertSurround_4().

#define SDL_AUDIO_ISFLOAT | ( |  | x | ) | (x & SDL_AUDIO_MASK_DATATYPE)

Definition at line 76 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice().

#define SDL_AUDIO_ISINT | ( |  | x | ) | (!SDL_AUDIO_ISFLOAT(x))

Definition at line 79 of file SDL_audio.h.

#define SDL_AUDIO_ISLITTLEENDIAN | ( |  | x | ) | (!SDL_AUDIO_ISBIGENDIAN(x))

Definition at line 80 of file SDL_audio.h.

#define SDL_AUDIO_ISSIGNED | ( |  | x | ) | (x & SDL_AUDIO_MASK_SIGNED)

Definition at line 78 of file SDL_audio.h.

Referenced by COREAUDIO_OpenDevice(), and SDL_BuildAudioCVT().

#define SDL_AUDIO_ISUNSIGNED | ( |  | x | ) | (!SDL_AUDIO_ISSIGNED(x))

Definition at line 81 of file SDL_audio.h.

#define SDL_AUDIO_MASK_BITSIZE (0xFF)

Definition at line 71 of file SDL_audio.h.

Referenced by SDL_ConvertMono(), SDL_ConvertSurround(), and SDL_ConvertSurround_4().

#define SDL_AUDIO_MASK_DATATYPE (1<<8)

Definition at line 72 of file SDL_audio.h.

#define SDL_AUDIO_MASK_ENDIAN (1<<12)

Definition at line 73 of file SDL_audio.h.

#define SDL_AUDIO_MASK_SIGNED (1<<15)

Definition at line 74 of file SDL_audio.h.

Referenced by SDL_ConvertMono(), SDL_ConvertSurround(), and SDL_ConvertSurround_4().

#define SDL_AUDIOCVT_PACKED

A structure to hold a set of audio conversion filters and buffers.

Definition at line 194 of file SDL_audio.h.

#define SDL_LoadWAV | ( |  | file,
|  |  | spec,
|  |  | audio_buf,
|  |  | audio_len
| ) |  | SDL_LoadWAV_RW(SDL_RWFromFile(file, "rb"),1, spec,audio_buf,audio_len)

Loads a WAV from a file. Compatibility convenience function.

Definition at line 419 of file SDL_audio.h.

#define SDL_MIX_MAXVOLUME 128

Definition at line 456 of file SDL_audio.h.

Referenced by SDL_MixAudioFormat().

## Typedef Documentation

typedef SDL_AudioFormat format

Definition at line 181 of file SDL_audio.h.

typedef Uint8 int len

Definition at line 159 of file SDL_audio.h.

typedef struct SDL_AudioCVT SDL_AudioCVT

typedef Uint32 SDL_AudioDeviceID

SDL Audio Device IDs.

A successful call to SDL_OpenAudio() is always device id 1, and legacy SDL audio APIs assume you want this device ID. SDL_OpenAudioDevice() calls always returns devices >= 2 on success. The legacy calls are good both for backwards compatibility and when you don't care about multiple, specific, or capture devices.

Definition at line 298 of file SDL_audio.h.

typedef Uint16 SDL_AudioFormat

Audio format flags.

These are what the 16 bits in SDL_AudioFormat currently mean... (Unspecified bits are always zero).

    ++-----------------------sample is signed if set
    ||
    ||       ++-----------sample is bigendian if set
    ||       ||
    ||       ||          ++---sample is float if set
    ||       ||          ||
    ||       ||          || +---sample bit size---+
    ||       ||          || |                     |
    15 14 13 12 11 10 09 08 07 06 05 04 03 02 01 00

There are macros in SDL 2.0 and later to query these bits.

Definition at line 64 of file SDL_audio.h.

typedef struct SDL_AudioSpec SDL_AudioSpec

The calculated values in this structure are calculated by SDL_OpenAudio().

typedef Uint8* stream

Definition at line 159 of file SDL_audio.h.

## Enumeration Type Documentation

enum SDL_AudioStatus

Enumerator
SDL_AUDIO_STOPPED |
SDL_AUDIO_PLAYING |
SDL_AUDIO_PAUSED |

Definition at line 363 of file SDL_audio.h.

## Function Documentation

DECLSPEC int SDLCALL SDL_AudioInit | ( | const char * | driver_name | ) |

Definition at line 562 of file SDL_audio.c.

References AudioBootStrap::demand_only, SDL_AudioDriver::desc, AudioBootStrap::desc, finalize_audio_entry_points(), i, SDL_AudioDriver::impl, AudioBootStrap::init, SDL_AudioDriver::name, AudioBootStrap::name, NULL, SDL_AudioQuit(), SDL_getenv(), SDL_INIT_AUDIO, SDL_memset(), SDL_SetError(), SDL_strlen(), SDL_strncasecmp(), and SDL_WasInit().

Referenced by SDL_InitSubSystem(), and SDLTest_CommonInit().

DECLSPEC void SDLCALL SDL_AudioQuit | ( | void |  | ) |

Definition at line 1175 of file SDL_audio.c.

References SDL_AudioDriverImpl::Deinitialize, free_device_list(), i, SDL_AudioDriver::impl, SDL_AudioDriver::inputDeviceCount, SDL_AudioDriver::inputDevices, SDL_AudioDriver::name, NULL, SDL_AudioDriver::outputDeviceCount, SDL_AudioDriver::outputDevices, SDL_arraysize, SDL_CloseAudioDevice(), and SDL_memset().

Referenced by SDL_AudioInit(), SDL_QuitSubSystem(), and SDLTest_CommonQuit().

DECLSPEC int SDLCALL SDL_BuildAudioCVT | ( | SDL_AudioCVT * | cvt,
|  | SDL_AudioFormat | src_format,
|  | Uint8 | src_channels,
|  | int | src_rate,
|  | SDL_AudioFormat | dst_format,
|  | Uint8 | dst_channels,
|  | int | dst_rate
| ) |  |

This function takes a source format and rate and a destination format and rate, and initializes the `cvt` structure with information needed by SDL_ConvertAudio() to convert a buffer of audio data from one format to the other.

Returns
  -1 if the format conversion is not supported, 0 if there's no conversion needed, or 1 if the audio filter is set up.

Definition at line 958 of file SDL_audiocvt.c.

References SDL_AudioCVT::buf, SDL_AudioCVT::dst_format, SDL_AudioCVT::filter_index, SDL_AudioCVT::filters, SDL_AudioCVT::len, SDL_AudioCVT::len_mult, SDL_AudioCVT::len_ratio, SDL_AudioCVT::needed, NULL, SDL_AudioCVT::rate_incr, SDL_AUDIO_BITSIZE, SDL_AUDIO_ISSIGNED, SDL_BuildAudioResampleCVT(), SDL_BuildAudioTypeCVT(), SDL_ConvertMono(), SDL_ConvertStereo(), SDL_ConvertStrip(), SDL_ConvertStrip_2(), SDL_ConvertSurround(), SDL_ConvertSurround_4(), SDL_InvalidParamError, SDL_SetError(), SDL_zerop, and SDL_AudioCVT::src_format.

Referenced by open_audio_device().

DECLSPEC void SDLCALL SDL_CloseAudio | ( | void |  | ) |

This function shuts down audio processing and closes the audio device.

Definition at line 1169 of file SDL_audio.c.

References SDL_CloseAudioDevice().

DECLSPEC void SDLCALL SDL_CloseAudioDevice | ( | SDL_AudioDeviceID | dev | ) |

Definition at line 1159 of file SDL_audio.c.

References close_audio_device(), get_audio_device(), and NULL.

Referenced by open_audio_device(), SDL_AudioQuit(), and SDL_CloseAudio().

DECLSPEC int SDLCALL SDL_ConvertAudio | ( | SDL_AudioCVT * | cvt | ) |

Once you have initialized the `cvt` structure using SDL_BuildAudioCVT(), created an audio buffer `cvt->buf`, and filled it with `cvt->len` bytes of audio data in the source format, this function will convert it in-place to the desired format.

The data conversion may expand the size of the audio data, so the buffer `cvt->buf` should be allocated after the `cvt` structure is initialized by SDL_BuildAudioCVT(), and should be `cvt->len*cvt->len_mult` bytes long.

Definition at line 774 of file SDL_audiocvt.c.

References SDL_AudioCVT::buf, SDL_AudioCVT::filter_index, SDL_AudioCVT::filters, SDL_AudioCVT::len, SDL_AudioCVT::len_cvt, NULL, SDL_SetError(), and SDL_AudioCVT::src_format.

Referenced by SDL_RunAudio().

DECLSPEC void SDLCALL SDL_FreeWAV | ( | Uint8 * | audio_buf | ) |

This function frees data previously allocated with SDL_LoadWAV_RW()

Definition at line 601 of file SDL_wave.c.

References SDL_free().

DECLSPEC const char* SDLCALL SDL_GetAudioDeviceName | ( | int | index,
|  | int | iscapture
| ) |  |

Get the human-readable name of a specific audio device. Must be a value between 0 and (number of audio devices-1). Only valid after a successfully initializing the audio subsystem. The values returned by this function reflect the latest call to SDL_GetNumAudioDevices(); recall that function to redetect available hardware.

The string returned by this function is UTF-8 encoded, read-only, and managed internally. You are not to free it. If you need to keep the string for any length of time, you should make your own copy of it, as it will be invalid next time any of several other SDL functions is called.

Definition at line 708 of file SDL_audio.c.

References DEFAULT_INPUT_DEVNAME, DEFAULT_OUTPUT_DEVNAME, SDL_AudioDriverImpl::HasCaptureSupport, SDL_AudioDriver::impl, SDL_AudioDriver::inputDeviceCount, SDL_AudioDriver::inputDevices, NULL, SDL_AudioDriverImpl::OnlyHasDefaultInputDevice, SDL_AudioDriverImpl::OnlyHasDefaultOutputDevice, SDL_AudioDriver::outputDeviceCount, SDL_AudioDriver::outputDevices, SDL_INIT_AUDIO, SDL_SetError(), and SDL_WasInit().

DECLSPEC SDL_AudioStatus SDLCALL SDL_GetAudioDeviceStatus | ( | SDL_AudioDeviceID | dev | ) |

Definition at line 1087 of file SDL_audio.c.

References SDL_AudioDevice::enabled, get_audio_device(), SDL_AudioDevice::paused, SDL_AUDIO_PAUSED, SDL_AUDIO_PLAYING, and SDL_AUDIO_STOPPED.

Referenced by SDL_GetAudioStatus().

DECLSPEC const char* SDLCALL SDL_GetAudioDriver | ( | int | index | ) |

Definition at line 553 of file SDL_audio.c.

References NULL, and SDL_GetNumAudioDrivers().

Referenced by SDLTest_CommonInit().

DECLSPEC SDL_AudioStatus SDLCALL SDL_GetAudioStatus | ( | void |  | ) |

Definition at line 1103 of file SDL_audio.c.

References SDL_GetAudioDeviceStatus().

DECLSPEC const char* SDLCALL SDL_GetCurrentAudioDriver | ( | void |  | ) |

This function returns the name of the current audio driver, or NULL if no driver has been initialized.

Definition at line 618 of file SDL_audio.c.

References SDL_AudioDriver::name.

Referenced by SDLTest_CommonInit().

DECLSPEC int SDLCALL SDL_GetNumAudioDevices | ( | int | iscapture | ) |

Get the number of available devices exposed by the current driver. Only valid after a successfully initializing the audio subsystem. Returns -1 if an explicit list of devices can't be determined; this is not an error. For example, if SDL is set up to talk to a remote audio server, it can't list every one available on the Internet, but it will still allow a specific host to be specified to SDL_OpenAudioDevice().

In many common cases, when this function returns a value <= 0, it can still successfully open the default device (NULL for first argument of SDL_OpenAudioDevice()).

Definition at line 671 of file SDL_audio.c.

References SDL_AudioDriverImpl::DetectDevices, free_device_list(), SDL_AudioDriverImpl::HasCaptureSupport, SDL_AudioDriver::impl, SDL_AudioDriver::inputDeviceCount, SDL_AudioDriver::inputDevices, SDL_AudioDriverImpl::OnlyHasDefaultInputDevice, SDL_AudioDriverImpl::OnlyHasDefaultOutputDevice, SDL_AudioDriver::outputDeviceCount, SDL_AudioDriver::outputDevices, SDL_AddCaptureAudioDevice(), SDL_AddOutputAudioDevice(), SDL_INIT_AUDIO, and SDL_WasInit().

Referenced by open_audio_device().

DECLSPEC int SDLCALL SDL_GetNumAudioDrivers | ( | void |  | ) |

Definition at line 547 of file SDL_audio.c.

References SDL_arraysize.

Referenced by SDL_GetAudioDriver(), and SDLTest_CommonInit().

DECLSPEC SDL_AudioSpec* SDLCALL SDL_LoadWAV_RW | ( | SDL_RWops * | src,
|  | int | freesrc,
|  | SDL_AudioSpec * | spec,
|  | Uint8 ** | audio_buf,
|  | Uint32 * | audio_len
| ) |  |

This function loads a WAVE from the data source, automatically freeing that source if `freesrc` is non-zero. For example, to load a WAVE file, you could do:

* SDL_LoadWAV_RW(SDL_RWFromFile("sample.wav", "rb"), 1, ...);
*

If this function succeeds, it returns the given SDL_AudioSpec, filled with the audio data format of the wave data, and sets `*audio_buf` to a malloc()'d buffer containing the audio data, and sets `*audio_len` to the length of that audio buffer, in bytes. You need to free the audio buffer with SDL_FreeWAV() when you are done with it.

This function returns NULL and sets the SDL error message if the wave file cannot be opened, uses an unknown data format, or is corrupt. Currently raw and MS-ADPCM WAVE files are supported.

Definition at line 405 of file SDL_wave.c.

References AUDIO_F32, AUDIO_S16, AUDIO_S32, AUDIO_U8, WaveFMT::bitspersample, WaveFMT::channels, SDL_AudioSpec::channels, chunk, DATA, Chunk::data, WaveFMT::encoding, FACT, FMT, SDL_AudioSpec::format, SDL_AudioSpec::freq, WaveFMT::frequency, IEEE_FLOAT_CODE, if(), IMA_ADPCM_CODE, IMA_ADPCM_decode(), InitIMA_ADPCM(), InitMS_ADPCM(), Chunk::length, LIST, Chunk::magic, MP3_CODE, MS_ADPCM_CODE, MS_ADPCM_decode(), NULL, PCM_CODE, ReadChunk(), RIFF, RW_SEEK_CUR, SDL_AudioSpec::samples, SDL_AUDIO_BITSIZE, SDL_free(), SDL_memset(), SDL_ReadLE32(), SDL_RWclose, SDL_RWseek, SDL_SetError(), SDL_SwapLE16, SDL_SwapLE32, SDL_zero, and WAVE.

DECLSPEC void SDLCALL SDL_LockAudio | ( | void |  | ) |

Definition at line 1137 of file SDL_audio.c.

References SDL_LockAudioDevice().

DECLSPEC void SDLCALL SDL_LockAudioDevice | ( | SDL_AudioDeviceID | dev | ) |

Definition at line 1127 of file SDL_audio.c.

References get_audio_device(), SDL_AudioDriver::impl, and SDL_AudioDriverImpl::LockDevice.

Referenced by SDL_LockAudio().

DECLSPEC void SDLCALL SDL_MixAudio | ( | Uint8 * | dst,
|  | const Uint8 * | src,
|  | Uint32 | len,
|  | int | volume
| ) |  |

This takes two audio buffers of the playing audio format and mixes them, performing addition, volume adjustment, and overflow clipping. The volume ranges from 0 - 128, and should be set to SDL_MIX_MAXVOLUME for full audio volume. Note this does not change hardware volume. This is provided for convenience – you can mix your own audio data.

Definition at line 1268 of file SDL_audio.c.

References SDL_AudioDevice::convert, SDL_AudioSpec::format, get_audio_device(), SDL_AudioCVT::needed, NULL, SDL_MixAudioFormat(), SDL_AudioDevice::spec, and SDL_AudioCVT::src_format.

DECLSPEC void SDLCALL SDL_MixAudioFormat | ( | Uint8 * | dst,
|  | const Uint8 * | src,
|  | SDL_AudioFormat | format,
|  | Uint32 | len,
|  | int | volume
| ) |  |

This works like SDL_MixAudio(), but you specify the audio format instead of using the format of audio device 1. Thus it can be used when no audio device is open at all.

Definition at line 90 of file SDL_mixer.c.

References ADJUST_VOLUME, ADJUST_VOLUME_U8, AUDIO_F32LSB, AUDIO_F32MSB, AUDIO_S16LSB, AUDIO_S16MSB, AUDIO_S32LSB, AUDIO_S32MSB, AUDIO_S8, AUDIO_U8, F, mix8, SDL_MIX_MAXVOLUME, SDL_SetError(), SDL_SwapBE32, SDL_SwapFloatBE, SDL_SwapFloatLE, and SDL_SwapLE32.

Referenced by SDL_MixAudio().

DECLSPEC int SDLCALL SDL_OpenAudio | ( | SDL_AudioSpec * | desired,
|  | SDL_AudioSpec * | obtained
| ) |  |

This function opens the audio device with the desired parameters, and returns 0 if successful, placing the actual hardware parameters in the structure pointed to by `obtained`. If `obtained` is NULL, the audio data passed to the callback function will be guaranteed to be in the requested format, and will be automatically converted to the hardware audio format if necessary. This function returns -1 if it failed to open the audio device, or couldn't set up the audio thread.

When filling in the desired audio spec structure,

- `desired->freq` should be the desired audio frequency in samples-per- second.
- `desired->format` should be the desired audio format.
- `desired->samples` is the desired size of the audio buffer, in samples. This number should be a power of two, and may be adjusted by the audio driver to a value more suitable for the hardware. Good values seem to range between 512 and 8096 inclusive, depending on the application and CPU speed. Smaller values yield faster response time, but can lead to underflow if the application is doing heavy processing and cannot fill the audio buffer in time. A stereo sample consists of both right and left channels in LR ordering. Note that the number of samples is directly related to time by the following formula:
  ms = (samples*1000)/freq
- `desired->size` is the size in bytes of the audio buffer, and is calculated by SDL_OpenAudio().
- `desired->silence` is the value used to set the buffer to silence, and is calculated by SDL_OpenAudio().
- `desired->callback` should be set to a function that will be called when the audio device is ready for more data. It is passed a pointer to the audio buffer, and the length in bytes of the audio buffer. This function usually runs in a separate thread, and so you should protect data structures that it accesses by calling SDL_LockAudio() and SDL_UnlockAudio() in your code.
- `desired->userdata` is passed as the first parameter to your callback function.

The audio device starts out playing silence when it's opened, and should be enabled for playing by calling `SDL_PauseAudio(0)` when you are ready for your audio callback function to be called. Since the audio driver may modify the requested size of the audio buffer, you should allocate any local mixing buffers after you open the audio device.

Definition at line 1049 of file SDL_audio.c.

References NULL, open_audio_device(), SDL_assert, SDL_AUDIO_ALLOW_ANY_CHANGE, SDL_INIT_AUDIO, SDL_InitSubSystem(), SDL_SetError(), and SDL_WasInit().

Referenced by SDLTest_CommonInit().

DECLSPEC SDL_AudioDeviceID SDLCALL SDL_OpenAudioDevice | ( | const char * | device,
|  | int | iscapture,
|  | const SDL_AudioSpec * | desired,
|  | SDL_AudioSpec * | obtained,
|  | int | allowed_changes
| ) |  |

Open a specific audio device. Passing in a device name of NULL requests the most reasonable default (and is equivalent to calling SDL_OpenAudio()).

The device name is a UTF-8 string reported by SDL_GetAudioDeviceName(), but some drivers allow arbitrary and driver-specific strings, such as a hostname/IP address for a remote audio server, or a filename in the diskaudio driver.

Returns
  0 on error, a valid device ID that is >= 2 on success.

SDL_OpenAudio(), unlike this function, always acts on device ID 1.

Definition at line 1078 of file SDL_audio.c.

References open_audio_device().

DECLSPEC void SDLCALL SDL_PauseAudio | ( | int | pause_on | ) |

Definition at line 1120 of file SDL_audio.c.

References SDL_PauseAudioDevice().

DECLSPEC void SDLCALL SDL_PauseAudioDevice | ( | SDL_AudioDeviceID | dev,
|  | int | pause_on
| ) |  |

Definition at line 1109 of file SDL_audio.c.

References get_audio_device(), SDL_AudioDriver::impl, SDL_AudioDriverImpl::LockDevice, SDL_AudioDevice::paused, and SDL_AudioDriverImpl::UnlockDevice.

Referenced by SDL_PauseAudio().

DECLSPEC void SDLCALL SDL_UnlockAudio | ( | void |  | ) |

Definition at line 1153 of file SDL_audio.c.

References SDL_UnlockAudioDevice().

DECLSPEC void SDLCALL SDL_UnlockAudioDevice | ( | SDL_AudioDeviceID | dev | ) |

Definition at line 1143 of file SDL_audio.c.

References get_audio_device(), SDL_AudioDriver::impl, and SDL_AudioDriverImpl::UnlockDevice.

Referenced by SDL_UnlockAudio().

typedef void | ( | SDLCALL * | SDL_AudioCallback | ) |

This function is called when the audio device needs more data.

Parameters

  userdata | An application-specific parameter saved in the SDL_AudioSpec structure
  stream | A pointer to the audio data buffer.
  len | The length of that buffer in bytes.

Once the callback returns, the buffer will no longer be valid. Stereo samples are stored in a LRLRLR ordering.